provide useful change information in an rss/atom feed of recent changes

NEW
Unassigned

Status

()

--
enhancement
10 years ago
7 years ago

People

(Reporter: tim, Unassigned)

Tracking

Details

Attachments

(5 attachments, 2 obsolete attachments)

(Reporter)

Description

10 years ago
User-Agent:       Mozilla/5.0 (X11; U; Linux i686; en-GB; rv:1.9) Gecko/2008061015 Firefox/3.0
Build Identifier: version 3.0.4

It would be good to have an rss feed that shows in each item's content a summary of what changed, much like the emails that are sent to people on the cc list.

A search for recently changed bugs converted to a feed is close, but it's hard to get a handle on what actually changed from looking at the feed without looking at the bug activity / comments for each bug in the list.

I'm not aware of any existing functionality that covers this.

Reproducible: Always

Steps to Reproduce:
search for bugs changed in x days, click "feed" link
look at content for an individual entry
Actual Results:  
[Bug 1415] blah blah
22/07/08 14:09
        Field	Value
        Opened
        	13:53:12
        Assignee
        	Tim
        Priority
        	P5
        Severity 
        	enhancement
        Status
        	ASSIGNED
        Changed
        	14:09:39

Expected Results:  
[tim] changed:

           What    |Removed                     |Added
----------------------------------------------------------------------------
                 CC|                            |[someoneelse]

comment #2 ...
here is the comment that was added
etc

Presumably the search/feed functionality can't be coerced into providing such a feed, so perhaps a dedicated file for producing such a feed would be an idea.

I'd have a stab at creating it if I had the time.

Comment 1

10 years ago
So, essentially, you want an Atom format for show_activity.cgi? I think we have a bug filed for that somewhere...
Assignee: query-and-buglist → create-and-change
Component: Query/Bug List → Creating/Changing Bugs
Whiteboard: DUPME?
(Reporter)

Comment 2

10 years ago
(In reply to comment #1)
> So, essentially, you want an Atom format for show_activity.cgi? I think we have
> a bug filed for that somewhere...
> 

Yes, exactly, but also including any added comments, and covering all bugs.

(Or perhaps as an extra feature a set of bugs based provided by a search)

So the feed would look something like this:


===========================================================
9:44 23rd July 2008, Bug #446598
Comment #2 added by Tim Abell
blah blah

           What    |Removed                     |Added
----------------------------------------------------------------------------
                 CC|                            |mymum@example.org
           Keywords|                            |fab_ideas

===========================================================
8:34 22rd July 2008, NEW Bug xxxx
full bug details here (as per email sent to cc list)

===========================================================
8:24 22rd July 2008, Bug xxxx FIXED
or something

===========================================================
etc

hope that helps

Comment 3

10 years ago
This is also something I had in mind. Not sure what to do with comments, though.
Status: UNCONFIRMED → NEW
Ever confirmed: true
Whiteboard: DUPME?

Comment 4

10 years ago
I think comments and bug activity should be interleaved (sorted by date)
I too think this should be an optionnal outup for a search, so you can follow changes made on a selection of bugs

Comment 5

10 years ago
Created attachment 354819 [details]
comments+activity RSS feed for 3.2

Hello!
My name is Vitaliy Filippov, I work in a Russian company named CustIS (www.custis.ru, team.custis.ru). We use slightly modified version of Bugzilla (2.20, but now we're upgrading to 3.2).
I want to submit a patch for Bugzilla 3.2 (this bug (446598) implementation). It includes a CGI script, a template, and a patch for another template (see archive contents). This script generates RSS feed from longdescs and bugs_activity DB tables; I suppose it will be useful for you.
(Reporter)

Comment 6

10 years ago
Created attachment 354959 [details]
my modifications to the patch

wow, nice one Vitaliy that's just what I was after.

I've attached my take on it.
Modifications are:
 - timezone
 - rearranged fields in template
 - added whether bug is NEW.

things I've noticed while playing with it (just for the record, i'm not asking you to change it):
 - language in the template is hard coded to 'Ru'
 - timezone is hard coded to +0300
 - doesn't pick up text for '*** Bug xxx has been marked as a duplicate of this bug. ***' (see longdescs.type http://www.ravenbrook.com/project/p4dti/tool/cgi/bugzilla-schema/index.cgi?action=single&version=3.0.2&view=View+schema#table-longdescs )
 - you can't tell from the rss feed which entries signify a new bug
 - comment link doesn't seem to work

I'm on v3.0.4 at the moment so some of the above may not be right for the latest revision

Comment 7

10 years ago
Please don't attach gzipped files; we cannot use PatchReader to analyse your patches. Also, your patch must be written against the current CVS code, i.e. Bugzilla 3.3. Comments from Tim about the language and the timezone must of course be fixed to have a chance to be accepted (or even reviewed).
(Reporter)

Comment 8

10 years ago
notes to self:

cc changes are slightly oddly worded:
Changed 'CC' to 'tim@timwise.co.uk'
rather than added/removed

the rss feed is rejected by thunderbird (but that could be specific to my bugzilla install)
(Reporter)

Comment 9

10 years ago
my co-workers on second rate operating systems inform me that outlook doesn't like the feed either

Comment 10

10 years ago
Created attachment 357668 [details]
comments+activity RSS feed for 3.2 - v2 - rss-comments.cgi

You *can* tell which entries signify a new bug :-) such entries have title "<Someone> added bug <ID>"
Feed is really rejected by thunderbird, but I don't know why O_o and thunderbird doesn't tell that to me...
 - Removed hardcode of timezone
 - Added a template filter to make absolute URLs in the RSS feed
In our installation, I've moved LookupNamedQuery from query.cgi to Bugzilla::Search to avoid duplicate code, but here is the version _with_ its own LookupNamedQuery.
Attachment #354819 - Attachment is obsolete: true

Comment 11

10 years ago
Created attachment 357669 [details] [diff] [review]
comments+activity RSS feed for 3.2 - v2 - Template.pm and t/004template.t patch

Comment 12

10 years ago
Created attachment 357672 [details]
comments+activity RSS feed for 3.2 - v2 - custom/list/comments.rss.tmpl

Comment 13

10 years ago
Ah, forgot - I also fixed "Changed 'CC' to '...'". Now every change is displayed as:
Changed '<field>' from '<from>' to '<to>'
or Added to '<field>': '<to>'
or Removed '<field>': '<from>'
While "it works in Thunderbird" is a nice thing for a feed, "it only has warnings, no errors, and I can justify my choice to ignore any remaining warnings from http://www.feedvalidator.org/" is a better development measure.

Comment 15

10 years ago
I remember I've tried to make feed "sane" for feedvalidator.org, I've done it, but thunderbird rejected it anyway...

Comment 16

9 years ago
Created attachment 400503 [details]
comments+activity RSS feed for 3.4.2 - v3 - rss-comments.cgi

1) Can't validate directly from our Bugzilla, because it's an intranet service, not available from the Internet.
2) Validating "by direct input" (copy-paste) show only 1 error - that feed isn't available by feed URI, this is caused by 1)
3) Previous version of rss-comments.cgi had VERY bad performance due to how MySQL executes joins and subqueries. I'm posting a highly optimized version without subqueries and without INNER JOINs. It's also built around the 3.4.2 version of Bugzilla.
Attachment #357668 - Attachment is obsolete: true

Comment 17

7 years ago
Created attachment 578891 [details] [diff] [review]
patch v4 - ignore previous pseudo-patches

I've updated the posted patches against bugzilla HEAD and fixed a few bugs.  The feed is properly passing validation.  You don't need to download rss-comments.cgi like the earlier patches.
Richardus, is this ready for review by a bugzilla peer?

Comment 19

7 years ago
Probably not.  The patch works but there are probably some things that wouldn't pass a review.  I don't know Perl and I certainly don't know Bugzilla so this patch is just my best effort.  Some stuff that I couldn't fix:
 - The SQL doesn't work on Postgres.  I see there's stuff in Bugzilla to work around this but I don't know how to work it in here.  Also, both of the sql regexes are probably wrong or at least need to be documented.
 - I ripped the SQL out of count() in Bugzilla/Comments.pl because I couldn't figure out how to use it.  This is probably wrong (but gives the right answer!).
 - The page is fast on my 3 bug Bugzilla install but I have no idea how it holds up in a big DB
 - I changed the LOGIN_REQUIRED to LOGIN_OPTIONAL.  I tested a "hidden" bug to see if it would appear in the unauthenticated output (it didn't) but I don't know enough about the access controls of Bugzilla to understand the implications of this change.
 - Copyright notice for new files
 - The other Bugzilla pages need one of those tags you stick in the header that tells the browser there's an RSS page available
You need to log in before you can comment on or make changes to this bug.